# InterWorx variables
%define pversion 2.4.6
%define bversion 23


####
#
# InterWorx note - this is derived from the mod_fastcgi rpm we build for system httpd
#
####



# $Id$
# Authority: shuff
# Upstream: http://fastcgi.com/fastcgi-developers

#%{?el4:%define _without_selinux 1}
#%{?el3:%define _without_selinux 1}
#%{?rh9:%define _without_selinux 1}
#%{?rh7:%define _without_selinux 1}

%define _without_selinux 1

Summary: Apache module that enables FastCGI
Name: iworx-mod_fastcgi
Version: 2.4.6
Release: %{bversion}%{?dist}
License: GPL/Apache License
Group: System Environment/Daemons
URL: http://www.fastcgi.com/

Packager: Tim College <tcollege@interworx.com>

Source0: http://www.fastcgi.com/dist/mod_fastcgi-%{version}.tar.gz
Source1: mod_fastcgi.te
Patch0: httpd-2.4.patch
Patch1: duplicate-header-nocheck.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: autoconf
BuildRequires: automake
BuildRequires: gcc-c++
BuildRequires: httpd-iworx
BuildRequires: apr-devel
BuildRequires: apr-util-devel
Requires: httpd-iworx

%{!?_without_selinux:BuildRequires: checkpolicy, policycoreutils}

%description
mod_fastcgi is a module for the Apache web server, that enables
FastCGI - a standards based protocol for communicating with
applications that generate dynamic content for web pages.

%prep
%setup -n mod_fastcgi-%{version}
%patch0 -p1
%patch1 -p1


%build
cp Makefile.AP2 Makefile
%{__make} top_dir="%{_iworx_dir_sysconf}/httpd"

%{__cat} <<EOF >fastcgi.httpd
LoadModule fastcgi_module %{_iworx_dir_lib}/httpd/modules/mod_fastcgi.so

# dir for IPC socket files
FastCgiIpcDir %{_iworx_dir_localstate}/run/%{name}

# wrap all fastcgi script calls in suexec
FastCgiWrapper Off

# global FastCgiConfig can be overridden by FastCgiServer options in vhost config
FastCgiConfig -idle-timeout 20 -maxClassProcesses 1

EOF

%{__cat} <<WRAPPER >php-wrapper
#!/bin/sh

PHPRC="/etc/php.ini"
export PHPRC
PHP_FCGI_CHILDREN=4
export PHP_FCGI_CHILDREN
exec /usr/bin/php-cgi
WRAPPER

%{__chmod} +x php-wrapper

%install
%{__rm} -rf %{buildroot}
%{__make} install top_dir="%{_iworx_dir_sysconf}/httpd" DESTDIR="%{buildroot}"
%{__install} -Dp -m0644 fastcgi.httpd %{buildroot}%{_iworx_dir_sysconf}/httpd/fastcgi.conf

# make an IPC sockets dir
%{__install} -d -m770 %{buildroot}%{_iworx_dir_localstate}/run/%{name}

### set up SELinux module if called for (adapted from munin.spec)
%if !%{?_without_selinux:1}
checkmodule -M -m -o %{name}.mod %{SOURCE1}
semodule_package -o %{name}.pp -m %{name}.mod
%{__install} -D -d -m0755 %{buildroot}%{_datadir}/selinux/targeted/
%{__install} %{name}.pp %{buildroot}%{_datadir}/selinux/targeted/
%endif

%pre
# make the iworx-web group (if needed)
/bin/grep "^%{_iworx_web_group}:" /etc/group >/dev/null || groupadd -r %{_iworx_web_group}

# make the iworx-web user (if needed)
/bin/grep "^%{_iworx_web_user}:" /etc/passwd >/dev/null || /usr/sbin/useradd \
        -g %{_iworx_web_group} -d / \
        -s /sbin/nologin -c %{name} -r %{_iworx_web_user}

%clean
%{__rm} -rf %{buildroot}

%post
%if !%{?_without_selinux:1}
semodule -i %{_datadir}/selinux/targeted/%{name}.pp
%endif

chown -R %{_iworx_web_user}:%{_iworx_web_group} %{_iworx_dir_localstate}/run/%{name}

%files
%defattr(-, root, root, 0755)
%doc CHANGES INSTALL* README docs/ php-wrapper
%config(noreplace) %{_iworx_dir_sysconf}/httpd/fastcgi.conf
%{_iworx_dir_lib}/httpd/modules/mod_fastcgi.so
%dir %attr(770,%{_iworx_web_user},%{_iworx_web_group}) %{_iworx_dir_localstate}/run/%{name}
%if !%{?_without_selinux:1}
%attr(0644, root, root) %{_datadir}/selinux/targeted/*
%endif

%changelog
* Mon Nov 15 2021 Tim College <tcollege@interworx.com>
- Add Almalinux 8 support

* Mon Nov 05 2018 Tim College <tcollege@interworx.com>
- Changed to run as iworx-web instead of iworx user
- Added code to create iworx-web user and group if needed

* Wed May 09 2018 Tim College <tcollege@interworx.com>
- Forked to create iworx-mod_fastcgi

* Thu Mar 09 2017 Tim College <tcollege@interworx.com>
- Add patch to prevent issues on duplicate response headers

* Wed Jan 04 2017 Tim College <tcollege@interworx.com>
- Modified default fastcgi.conf to work with PHP-FPM

* Mon May 07 2012 William Horka <whorka@hmdc.harvard.edu> 2.4.6-2
- Add selinux module
- Remove unused log dir and add IPC socket dir
- Add FastCgiWrapper, FastCgiConfig, and FastCgiWrapper to fastcgi.conf
- Set httpd User and Group in fastcgi.conf so mod_fastcgi.so will load

* Fri Aug 26 2011 Philip Durbin <philipdurbin@gmail.com> 2.4.6-1
- Initial release, based on mod_suphp.spec
